#include <bits/stdc++.h>
using namespace std;
#define int long long

int const LOG = 19;
int const MAXN = 4e5;
int ST[LOG][MAXN];

int get (int l, int r) {
    int lg = __lg (r - l);
    return min(ST[lg][l], ST[lg][r - (1 << lg)]);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);


    int n, k;
    cin >> n >> k;
    int d = n - k + 1;
    vector<int> v(n);
    for (int i = 0; i < n; i++) cin >> v[i];
    for (int i = 0; i < n; i++) ST[0][i] = v[i];
    for (int log = 1; log < LOG; log++) {
        for (int i = 0; i + (1 << log) <= n; i++) {
            ST[log][i] = min(ST[log - 1][i], ST[log - 1][(1 << (log - 1)) + i]);
        }
    }

    int sum = 0;
    int ans = 0;
    for (int i = 0; i < d; i++) {
        sum += v[i];
        ans = max(ans, sum - get(i + 1, n));
    }

    int ind1 = 0, ind2 = d;
    while (ind1 < n) {
        if (ind2 < n - 1) {
            sum += v[ind2];
            sum -= v[ind1];
            ind2++;
            ind1++;
            int mn = min(get(0, ind1), get(ind2, n));
            ans = max(ans, sum - mn);
        }
        else if (ind2 == n - 1) {
            sum += v[ind2];
            sum -= v[ind1];
            ind2++;
            ind1++;
            ans = max(ans, sum - get(0, ind1));
        }
        else {
            sum -= v[ind1];
            ind1++;
            ans = max(ans, sum - get(0, ind1));
        }
    }
    cout << ans;

}